package com.tzld.piaoquan.wecom.job;

import com.aliyun.odps.data.Record;
import com.tzld.piaoquan.wecom.common.constant.MiniprogramConstant;
import com.tzld.piaoquan.wecom.dao.mapper.UserMapper;
import com.tzld.piaoquan.wecom.model.bo.PushMessage;
import com.tzld.piaoquan.wecom.model.po.User;
import com.tzld.piaoquan.wecom.utils.OdpsUtil;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.redis.core.RedisTemplate;
import org.springframework.stereotype.Component;
import org.springframework.util.CollectionUtils;

import java.util.*;
import java.util.stream.Collectors;

@Component
public class WeComMessageDataJob {


    @Autowired
    private UserMapper userMapper;

    @Autowired
    private RedisTemplate<String, Object> redisTemplate;

    private static final int sum = 3;

    List<PushMessage> goodList = new ArrayList<>();
    List<Long> saveList = new ArrayList<>();

    void init() {
        List<Record> recordList = OdpsUtil.getOdpsData("SELECT * FROM loghubods.history_good_video_can_push_user_list where dt = 20240922;");
        if (CollectionUtils.isEmpty(recordList)) {
            return;
        }
        List<PushMessage> list = new ArrayList<>();
        for (Record record : recordList) {
            PushMessage pushMessage = new PushMessage();
            Long videoId = Long.parseLong((String) record.get(0));
            StringBuilder stringBuilder = new StringBuilder((String) record.get(1));
            stringBuilder.delete(0, 1);
            stringBuilder.delete(stringBuilder.length() - 1, stringBuilder.length());
            Set<Long> userIds = Arrays.stream(stringBuilder.toString().split(",")).map(String::trim).map(Long::parseLong).collect(Collectors.toSet());
            pushMessage.setVideoId(videoId);
            pushMessage.setUserIds(userIds);
            list.add(pushMessage);
        }
        goodList = list;
        saveList = Objects.requireNonNull(redisTemplate.opsForList().range(MiniprogramConstant.GUARANTEED_MINIPROGRAM_KEY, 0, 2)).stream().map(o -> (Long) o).collect(Collectors.toList());
    }



    public String getPushKey(User user) {
        int i = 0;
        StringBuilder key = new StringBuilder();
        for (PushMessage pushMessage : goodList) {
            if (pushMessage.getUserIds().contains(user.getId())) {
                if (key.length() == 0) {
                    key.append(pushMessage.getVideoId());
                    i++;
                } else {
                    key.append("_");
                    key.append(pushMessage.getVideoId());
                }
                i++;
                if (i > sum) {
                    return key.toString();
                }
            }
        }
        for (Long videoId : saveList) {
            if (key.length() == 0) {
                key.append(videoId);
                i++;
            } else {
                key.append("_");
                key.append(videoId);
            }
            i++;
            if (i > sum) {
                return key.toString();
            }
        }
        return key.toString();
    }
}
